﻿using System;

namespace SuperHero
{
    class Main
    {
        Hero player;
        SaveSystem save = new SaveSystem();

        public Main()
        {

        }

        public void startUp()
        {
            Console.Title = "SuperHero";

            Console.Clear();
            Console.BackgroundColor = ConsoleColor.Blue;
            Console.WriteLine("===============================================================================");
            Console.WriteLine("==========================Welcome to SuperHero!================================");
            Console.WriteLine("===============================================================================");
            Console.BackgroundColor = ConsoleColor.Black;

            Console.WriteLine("Press 1 to start a new game.");
            Console.WriteLine("Press 2 to load a new game.");
            ConsoleKeyInfo key = Console.ReadKey();

            if (key.Key == ConsoleKey.D1)
            {
                startUpSecuence();
            }
            if (key.Key == ConsoleKey.D2)
            {
                try
                {
                    player = new Hero(null, 0, 0, null);
                    save.load(player);
                    mainMenu(true);
                }
                catch (Exception ex)
                {
                    Console.Clear();
                    Console.WriteLine("SAVESYSTEM: Failed to load!");
                    Console.Write(System.Environment.NewLine + ex);
                    Console.ReadKey();
                    startUp();
                }
            }
        }

        public void startUpSecuence()
        {
            int age = 0;
            Console.Title = "SuperHero";

            Console.Clear();
            Console.WriteLine("Hey! You are a Super-hero! You didn't know that! did you?");
            Console.WriteLine("Give yourself a name:");
            string name = Console.ReadLine();
            if (name == ""  || name == null)
            {
                Console.Clear();
                Console.WriteLine("*headdesk*");
                Console.ReadKey();
                startUpSecuence();
            }
            Console.Title = "SuperHero - " + name;


            Console.Clear();
            Console.WriteLine("Of course you have a age! What's your age?");
            try
            {
                age = Convert.ToInt32(Console.ReadLine());
            }
            catch
            {
                Console.Clear();
                Console.WriteLine("That's no valid age! Now you can do everything again.");
                Console.ReadKey();
                startUpSecuence();
            }
            Console.Clear();


            if (age < 0)
            {
                Console.Write("You are too young to play this bad-ass game. Also I am smarter than you," + '\n' + "who has this age: " + age.ToString() + "?");
                Console.ReadLine();
                Console.Write("Exacly. Nobody except dumb people. Now give yourself another try," + '\n' + "and also another name because that was dumb too, before I call the police.");
                Console.ReadKey();
                startUpSecuence();
            }
            if (age >= 74)
            {
                Console.WriteLine("Whoa! That's old! What's your power, demented elderly?");
            }
            else
            {
                Console.WriteLine("What's your power, " + name + "?");
            }
            string pwr = Console.ReadLine();


            Console.Clear();
            if (pwr.Contains("fart"))
            {
                Console.Write("djeez. Couldn't you just pick another power? I had hunderts and hunderts of" + '\n' + "people who pick " + pwr + "." + '\n');
                Console.WriteLine("Anyways, ");
            }
            else
            {
                if (pwr.Contains("rape") || pwr.Contains("raping"))
                {
                    Console.Title = "YOU CRIMINAL";
                    Console.WriteLine("O_O I am calling the police!");
                    Console.WriteLine("I wont tolerate this kind of people. Walk to hell.");
                    Console.ReadKey();
                    startUpSecuence();
                }
            }

            //player gets defined
            player = new Hero(name, age, 150, pwr);
            Console.WriteLine("Congratulations! You are now a super-hero! Good luck fighting badguys.");
            Console.ReadKey();
            mainMenu();
        }

        public void mainMenu(bool justLoaded = false)
        {
            Console.Clear();

            //award system
            if (player.wonTimes >= 10 && !player.awards.ToLower().Contains("won 10 times") && player.wonTimes < 25)
            {
                addAward("Won 10 times");
            }
            if (player.wonTimes >= 25 && !player.awards.ToLower().Contains("won 25 times"))
            {
                addAward("Won 25 times");
            }

            checkEasterEggs();

            if (!justLoaded)
            {
                try
                {
                    save.write(player);
                }
                catch
                {
                    Console.WriteLine("SAVESYSTEM: I failed to save you, " + player.name + "!");
                }
            }

            Console.Title = "SuperHero - " + player.name;
            Console.Write(player.specs() + System.Environment.NewLine + System.Environment.NewLine);
            Console.WriteLine("Press 1 to go fighting.");
            Console.WriteLine("Press 2 to go to the store.");
            Console.WriteLine("Press any other key to exit.");
            ConsoleKeyInfo key = Console.ReadKey();

            if (key.Key == ConsoleKey.D1)
            {
                fight();
            }
            if (key.Key == ConsoleKey.D2)
            {
                shop();
            }
            if (key.Key == ConsoleKey.C)
            {
                credits(true);
            }
        }

        public void fight()
        {
            player.health = 50;
            Random rand = new Random();
            Hero opponent = new Hero(opponentName(), rand.Next(4, 62), rand.Next(5, 29) + (player.wonTimes * rand.Next(1, 5)), opponentPower(), opponentAwards(), opponentWeapon(),
                opponentArmor(), opponentAccesoire());


            Console.Clear();
            Console.WriteLine("Your opponent:");
            Console.Write(opponent.specs() + System.Environment.NewLine + System.Environment.NewLine + System.Environment.NewLine);

            Console.WriteLine(opponent.name + " says: " + opponentScreams());
            string anwser1 = Console.ReadLine();
            Console.WriteLine(player.name + " says: " + anwser1);
            Console.WriteLine(opponent.name + " says: " + opponentScreams());
            string anwser2 = Console.ReadLine();
            Console.WriteLine(player.name + " says: " + anwser2);
            Console.ReadKey();

            fightLoop(opponent);
        }

        public void fightLoop(Hero opponent)
        {
            Random rand = new Random();

            Console.Clear();
            Console.WriteLine("Your health: " + player.health.ToString() + " | " + opponent.name + "\'s health: " + opponent.health.ToString());
            Console.WriteLine("Press 1 to hit your opponent.");
            Console.WriteLine("Press 2 to run away from you opponent");

            ConsoleKeyInfo key = Console.ReadKey();
            Console.Clear();

            if (key.Key == ConsoleKey.D1)
            {
                int damageToOpponent = rand.Next(2, 11);

                //weapon systen
                if (player.weapon.ToLower().Contains("coughing"))
                {
                    damageToOpponent += rand.Next(0, 2);
                }
                if (player.weapon.ToLower().Contains("windows 95 home basic oem os install disc"))
                {
                    damageToOpponent += rand.Next(0, 3);
                }
                if (player.weapon.ToLower().Contains("stapler"))
                {
                    damageToOpponent += rand.Next(1, 4);
                }
                if (player.weapon.ToLower().Contains("robot pet"))
                {
                    damageToOpponent += rand.Next(3, 5);
                }
                if (player.weapon.ToLower().Contains("pancake pan"))
                {
                    damageToOpponent += rand.Next(5, 10);
                }
                opponent.health -= damageToOpponent;


                Console.WriteLine("You hitted " + opponent.name + " with " + damageToOpponent + " healthpoints!");
                Console.ReadKey();
            }
            else if (key.Key == ConsoleKey.D2)
            {
                int canRunAway = rand.Next(0, 100);

                if (canRunAway < 30)
                {
                    Console.WriteLine("Phew! You escaped! That was a close one.");
                    Console.ReadKey();
                    mainMenu();
                }
                else
                {
                    Console.WriteLine("You failed to escape!");
                    Console.ReadKey();
                }
            }
            else
            {
                Console.WriteLine("You can't quit now! You are fighting!");
                Console.ReadKey();
                fightLoop(opponent);
            }

            Console.Clear();
            int dammageToPlayer = rand.Next(3, 9) + player.wonTimes;


            //armor system
            if (player.armor.ToLower().Contains("simpsons socks"))
            {
                dammageToPlayer -= rand.Next(1, 2);
            }
            if (player.weapon.ToLower().Contains("robot pet"))
            {
                dammageToPlayer -= rand.Next(0, 1);
            }
            if (player.armor.ToLower().Contains("pyjama's"))
            {
                dammageToPlayer -= rand.Next(2, 3);
            }
            if (player.armor.ToLower().Contains("ghost clothes"))
            {
                dammageToPlayer -= 4;
            }
            if (player.armor.ToLower().Contains("leaden armor"))
            {
                dammageToPlayer -= rand.Next(3, 8);
            }
            if (player.accesoire.ToLower().Contains("flashlight"))
            {
                dammageToPlayer--;
            }
            if (player.accesoire.ToLower().Contains("scroll of power"))
            {
                dammageToPlayer -= rand.Next(0, 4);
            }

            if (dammageToPlayer < 0)
            {
                dammageToPlayer = 0;
            }
            player.health -= dammageToPlayer;

            Console.WriteLine(opponent.name + " hitted you with " + dammageToPlayer + " healthpoints!");
            Console.ReadKey();

            if (opponent.health < 1)
            {
                Console.Clear();
                Console.WriteLine("You defeated " + opponent.name + "! Congratulations!");
                player.money += opponent.money;
                Console.WriteLine("You've stole from your opponent " + opponent.money + " money!");
                player.wonTimes++;
                Console.ReadKey();
                mainMenu();
            }
            else if (player.health < 1)
            {
                gameOverSecuence(opponent);
            }
            else
            {
                fightLoop(opponent);
            }
        }

        public void shop()
        {
            Console.Title = "SuperHero - Shop";
            Console.Clear();
            Console.WriteLine("Welcome to the shop. We have almost every useless thing here you can imagine, but you possibly don't find what you need.");
            Console.WriteLine("Money: " + player.money);
            Console.WriteLine();
            Console.WriteLine("Press 1 to go to the weapon section.");
            Console.WriteLine("Press 2 to go to the armor section.");
            Console.WriteLine("Press 3 to go to the accesoires section.");
            Console.WriteLine("Press any other key to go to the main menu.");

            ConsoleKeyInfo key = Console.ReadKey();
            if (key.Key == ConsoleKey.D1)
            {
                weaponStore();
            }
            else if (key.Key == ConsoleKey.D2)
            {
                armorStore();
            }
            else if (key.Key == ConsoleKey.D3)
            {
                accesoiresStore();
            }
            else
            {
                mainMenu();
            }
        }

        private void weaponStore()
        {
            Console.Title = "SuperHero - Weaponshop";
            Console.Clear();
            Console.WriteLine("Weaponshop");
            Console.WriteLine("Money: " + player.money);
            Console.WriteLine();
            Console.WriteLine("Press 1 to view coughing.");
            Console.WriteLine("Press 2 to view Windows 95 disc.");
            Console.WriteLine("Press 3 to view the stapler.");
            Console.WriteLine("Press 4 to view the Robot pet");
            Console.WriteLine("Press 5 to view the Pancake pan");

            ConsoleKeyInfo key = Console.ReadKey();

            if (key.Key == ConsoleKey.D1)
            {
                Product p = new Product("coughing", "This drink is full with bad things. First of all somebody pneumonia has drunk a part of it, it tastes bad and it is called \"Supermarket diet coke\"" + 
                    ". You don't have to ask anymore questions I guess.", "0 - 2", "0", 75);
                buy(p, 0);
            }
            else if (key.Key == ConsoleKey.D2)
            {
                Product p = new Product("Windows 95 Home Basic OEM OS install disc", "This old disc is so old that is has become terrifying. Because Windows 95 is \"Strong coded\", the disc is also"
                    + "strong. This tool will definetly help you defeating other people", "0 - 3", "0", 150);
                buy(p, 0);
            }
            else if (key.Key == ConsoleKey.D3)
            {
                Product p = new Product("stapler", "This stapler is... No it is just a stapler. You can shoot clamps to somebody, or you could instead punch somebody with it.", "1 - 4", "0", 320);
                buy(p, 0);
            }
            else if (key.Key == ConsoleKey.D4)
            {
                Product p = new Product("Robot pet", "This robot pet is a actually a malfunctioning piece of metal found on the junkyard, that is only called robot pet because it randomly attacks" +
                    " things.", "1 - 4", "0 - 1", 650);
                buy(p, 0);
            }
            else if (key.Key == ConsoleKey.D5)
            {
                Product p = new Product("Pancake pan", "This pancakepan is very old and used by a grandma that hits its childeren with it. Never used for baking pancakes. You will defeat your " +
                    "opponents easily with this thing. And you can bake pancakes with it, too.", "5 - 10", "0", 1000);
                buy(p, 0);
            }
        }

        private void armorStore()
        {
            Console.Title = "SuperHero - Armorshop";
            Console.Clear();
            Console.WriteLine("Armorshop");
            Console.WriteLine("Money: " + player.money);
            Console.WriteLine();
            Console.WriteLine("Press 1 to view Simpsons socks.");
            Console.WriteLine("Press 2 to view Pyjama's.");
            Console.WriteLine("Press 3 to view Ghost clothes");
            Console.WriteLine("Press 4 to view Leaden armor");

            ConsoleKeyInfo key = Console.ReadKey();

            if (key.Key == ConsoleKey.D1)
            {
                Product p = new Product("Simpsons socks", "These socks are full with nostalgic feelings and great memories. When people see these socks they will be distracted and they think \"good old times.\"",
                    "0", "1 - 2", 200);
                buy(p, 1);
            }
            else if (key.Key == ConsoleKey.D2)
            {
                Product p = new Product("Pyjama's", "These pyjama's are the classic Pyjama's with teddybears on it, those teddybears will protect you from the \"darkness\" since you was a kid." +
                    " There's a rumor that Pyjama Sam wore these, but it was never confirmed.",
                    "0", "2 - 3", 350);
                buy(p, 1);
            }
            else if (key.Key == ConsoleKey.D3)
            {
                Product p = new Product("Ghost clothes", "These ghost clothes are the perfect disguise(Not really, everyone will look at you weird if you wear these). The white cloth makes it hard to see the body" +
                    ", so your enemy's can't see where your body is to hit it.", "0", "4", 575);
                buy(p, 1);
            }
            else if (key.Key == ConsoleKey.D4)
            {
                Product p = new Product("Leaden armor", "Some archaeologists have found leaden armor, probally from an old knight who didn't have enough money for cast iron, so instead he crafted this." +
                    " He never weared it thought, because it is too heavy to wear.", "0", "3-8", 900);
                buy(p, 1);
            }
        }

        private void accesoiresStore()
        {
            Console.Title = "Superhero - Accesoiresshop";
            Console.Clear();
            Console.WriteLine("Accesoiresshop");
            Console.WriteLine("Money: " + player.money);
            Console.WriteLine();
            Console.WriteLine("Press 1 to view Flashlight.");
            Console.WriteLine("Press 2 to view the Power scroll.");

            ConsoleKeyInfo key = Console.ReadKey();

            if (key.Key == ConsoleKey.D1)
            {
                Product p = new Product("Flashlight", "With this flashlight you can blind your enemy's with it, it is a rumor that this is the flashlight from pyjama sam, that was taken by the trees." +
                    " And of course you can see yourself in the dark with it.", "0", "1", 200);
                buy(p, 2);
            }
            else if (key.Key == ConsoleKey.D2)
            {
                Product p = new Product("Scroll of power", "An old woman found this in her house. There's all weird chinese text on it(and signs of crayons), but it must be a legendary scroll. " +
                    "Warrenty void when bought. Doesn't it work? All your fault.", "0 - 4", "0", 300);
                buy(p, 2);
            }
        }

        private void checkEasterEggs()
        {
            if (player.name == "joppiesaus")
            {
                player.power = "I coded this game";
            }
            if (player.accesoire.ToLower() == "flashlight" && player.armor.ToLower() == "pyjama's")
            {
                player.money += 100;
                player.power = player.power + ", having all Pyjama Sam gear";
            }
            if (player.name == "Demented" && player.power == "Demented")
            {
                player.awards = "Can't remember";
            }
        }

        public void buy(Product product, int value)
        {
            Console.Title = "SuperHero - viewing " + product.name;
            Console.Clear();
            Console.Write(product.specs() + System.Environment.NewLine + System.Environment.NewLine + System.Environment.NewLine);
            Console.WriteLine("Press 1 to buy " + product.name);
            Console.WriteLine("Press any other key to go back to the shop.");

            ConsoleKeyInfo key = Console.ReadKey();

            if (key.Key == ConsoleKey.D1)
            {
                if (player.money >= product.price)
                {
                    if (value == 0)
                    {
                        player.weapon = product.name;
                    }
                    else if (value == 1)
                    {
                        player.armor = product.name;
                    }
                    else
                    {
                        player.accesoire = product.name;
                    }
                    player.money -= product.price;
                    mainMenu();
                }
                else
                {
                    Console.Clear();
                    Console.WriteLine("You can't pay " + product.name + ". Press any key to go back to the shop.");
                    Console.ReadKey();
                    shop();
                }
            }
            else
            {
                shop();
            }
        }

        public void addAward(string award)
        {
            Console.Clear();
            Console.WriteLine("Congratulations " + player.name + "! You won a new award called: \"" + award + "\" !");
            player.awards = award;
            Console.ReadKey();
            Console.Clear();
            mainMenu();
        }

        public void gameOverSecuence(Hero trollguy, bool creditsAfterDead = true)
        {
            Console.Title = "===GAME OVER===";
            Console.Clear();
            Console.WriteLine("===============================================================================");
            Console.WriteLine("===================================GAME OVER===================================");
            Console.WriteLine("===============================================================================");
            Console.WriteLine("You failed to defeat " + trollguy.name);
            Console.WriteLine("");
            Console.WriteLine("You lasted " + player.wonTimes + " fights.");
            Console.WriteLine("Rank achieved: " + getRank(player));
            if (player.wonTimes <= 0)
            {
                Console.WriteLine("Which means, you are a person who just press buttons on his / her keyboard while fighting.");
                Console.WriteLine("Idiot. -_-");
            }
            Console.ReadKey();
            if (creditsAfterDead)
            {
                credits();
            }
        }

        public void credits(bool returnToMainMenu = false)
        {
            Console.Clear();
            Console.Title = "SuperHero - Credits";
            Console.WriteLine("===============================================================================");
            Console.WriteLine("===================================Credits=====================================");
            Console.WriteLine("===============================================================================");
            string mscoreLib = string.Format("{0}", typeof(String).Assembly.GetName().Version);
            Console.WriteLine("SuperHero version " + System.Reflection.Assembly.GetExecutingAssembly().GetName().Version + ", mscorelib version " + mscoreLib);
            Console.WriteLine("\"A derp, very derp console RPG(sorta). Which has yet that unique, old feeling.\"");
            Console.WriteLine("Thanks for viewing the credits & playing SuperHero, " + player.name + "!");
            Console.WriteLine("Coders: joppiesaus");
            Console.WriteLine("Testers: Anoniemspy700");
            Console.ReadKey();
            if (returnToMainMenu)
            {
                mainMenu();
            }
        }

#region string generators

        public string getRank(Hero hero)
        {
            if (hero.wonTimes <= 0)
            {
                return "Extreme noob / prostitute";
            }
            else if (hero.wonTimes >= 1 && hero.wonTimes < 5)
            {
                return "Beginner";
            }
            else if (hero.wonTimes >= 5 && hero.wonTimes < 10)
            {
                return "Known";
            }
            else if (hero.wonTimes >= 10 && hero.wonTimes < 25)
            {
                return "Life-saver";
            }
            else if (hero.wonTimes >= 25 && hero.wonTimes < 50)
            {
                return "World wide known true hero";
            }
            else
            {
                return "Galaxy hero";
            }
        }

        public string opponentName()
        {
            string w1 = "Mister Bad;The Unexplained;The Weird;The Disabled;The Drunk;The Immortal;The Silly;The Awsome;The Demented;The Unpleasant;The Sleepy;The Flying;The Undead;" +
                "The Genius";
            string w2 = "Stewardess;Fruit-guy;Idiot;Hippy;Cat;Duck;Rat;Worm;Aligator;Elderly;Baby;Teenager;Dictator;Calculator;Garbageman;Actor;Atsronaut;Dictator;Negotiator;Pokemon;" +
                "Engineer;";

            Random rand = new Random();

            string[] w1_ = w1.Split(';');
            string before = w1_[rand.Next(0, w1_.Length - 1)];

            string[] w2_ = w2.Split(';');
            string after = w2_[rand.Next(0, w2_.Length - 1)];

            return before + " " + after;
        }

        public string opponentPower()
        {
            string w = "Fighting;Being drunk;Slapping;Kicking;Make up nice names;Having a nice CV;Know how to football;";

            Random rand = new Random();

            string[] w_ = w.Split(';');
            return w_[rand.Next(0, w_.Length - 1)];
        }

        public string opponentAwards()
        {
            string w = "None;\"Forever alone\";None;Glitched-out 50 times;Being stapled in the head;Tried to get a job 10 times;Lost 10 times;";

            Random rand = new Random();

            string[] w_ = w.Split(';');
            return w_[rand.Next(0, w_.Length - 1)];
        }

        public string opponentScreams()
        {
            string w = "You shall not pass!;Are you feeling lucky, punk?;You cannot defeat me!;Bring it on!;You cannot protect the city from my powers!;Muahahaha!;Look at my weapons!;You are nothing in my world!" +
                ";Do you think you are tough?;I don't accept snitches in my city!;I don't feel comfortable with you here!;Do you think beating me up is going to work out?;";

            Random rand = new Random();

            string[] w_ = w.Split(';');
            return w_[rand.Next(0, w_.Length - 1)];
        }

        public string opponentArmor()
        {
            string w = "Piece of cardboard;None;None;None;";

            Random rand = new Random();

            string[] w_ = w.Split(';');
            return w_[rand.Next(0, w_.Length - 1)];
        }

        public string opponentWeapon()
        {
            string w = "Screaming;None;None;None;";

            Random rand = new Random();

            string[] w_ = w.Split(';');
            return w_[rand.Next(0, w_.Length - 1)];
        }

        public string opponentAccesoire()
        {
            string w = "Plastic ring;None;None;None;";

            Random rand = new Random();

            string[] w_ = w.Split(';');
            return w_[rand.Next(0, w_.Length - 1)];
        }
        #endregion        
    }
}