﻿using System;
using System.Numerics;

namespace Encryption
{
    /// <summary>
    /// Generates a new class "Communicate64Encryption". Made by: Joppiesaus
    /// </summary>
    public class Communicate64Encryption
    {
        public Communicate64Encryption()
        {

        }

        /// <summary>
        /// Encrypts the string to Communicate64.
        /// </summary>
        /// <param name="input">Input string that needs to be encrypted</param>
        /// <returns>Output string that is encrypted to Communicate64</returns>
        public string encrypt(string input)
        {
            input = input.ToLower();
            input = input.Replace(",", "");

            //numbers
            input = input.Replace(System.Environment.NewLine, "ENTER");
            input = input.Replace(" ", "SPACE");
            input = input.Replace("0", "ZERO");
            input = input.Replace("1", "ONE");
            input = input.Replace("2", "TWO");
            input = input.Replace("3", "THREE");
            input = input.Replace("4", "FOUR");
            input = input.Replace("5", "FIVE");
            input = input.Replace("6", "SIX");
            input = input.Replace("7", "SEVEN");
            input = input.Replace("8", "EIGHT");
            input = input.Replace("9", "NINE");

            //char's
            input = input.Replace("a", "12");
            input = input.Replace("b", "13");
            input = input.Replace("c", "14");
            input = input.Replace("d", "15");
            input = input.Replace("e", "16");
            input = input.Replace("f", "17");
            input = input.Replace("g", "18");
            input = input.Replace("h", "19");
            input = input.Replace("i", "20");
            input = input.Replace("j", "21");
            input = input.Replace("k", "22");
            input = input.Replace("l", "23");
            input = input.Replace("m", "24");
            input = input.Replace("n", "25");
            input = input.Replace("o", "26");
            input = input.Replace("p", "27");
            input = input.Replace("q", "28");
            input = input.Replace("r", "29");
            input = input.Replace("s", "30");
            input = input.Replace("t", "31");
            input = input.Replace("u", "32");
            input = input.Replace("v", "33");
            input = input.Replace("w", "34");
            input = input.Replace("x", "35");
            input = input.Replace("y", "36");
            input = input.Replace("z", "37");

            //div
            input = input.Replace("!", "38");
            input = input.Replace("[", "39");
            input = input.Replace("]", "40");
            input = input.Replace("=", "41");
            input = input.Replace(".", "42");
            input = input.Replace("&", "43");
            input = input.Replace("@", "44");

            input = input.Replace("ENTER", "00");
            input = input.Replace("SPACE", "01");
            input = input.Replace("ZERO", "02");
            input = input.Replace("ONE", "03");
            input = input.Replace("TWO", "04");
            input = input.Replace("THREE", "05");
            input = input.Replace("FOUR", "06");
            input = input.Replace("FIVE", "07");
            input = input.Replace("SIX", "08");
            input = input.Replace("SEVEN", "09");
            input = input.Replace("EIGHT", "10");
            input = input.Replace("NINE", "11");

            input = input.Insert(0, "1");

            //tweak the length
            int length = input.Length;
            while (length < 7)
            {
                length++;
            }

            //secret formulla
            BigInteger outputInt = BigInteger.Parse(input);
            outputInt += outputInt ^ outputInt;
            string finalString = outputInt.ToString();
            BigInteger final = BigInteger.Parse(finalString);

            Random rand = new Random(finalString.Length);
            final += (rand.Next(1, 10000000) ^ 9000000);

            return final.ToString();
        }

        /// <summary>
        /// Decrypts the string from Communicate64 to a string.
        /// </summary>
        /// <param name="input">Input string that needs to be decrypted</param>
        /// <returns>Output string that is decrypted to a normal string</returns>
        public string decrypt(string input)
        {
            input = input.ToLower().Replace(",", "").Replace(" ", "");

            BigInteger outputInt = BigInteger.Parse(input);
            Random rand = new Random(input.Length);
            outputInt -= (rand.Next(1, 10000000) ^ 9000000);
            BigInteger final = 0;
            final -= outputInt ^ outputInt;
            string output = outputInt.ToString().Remove(0, 1);


            //insert "," so numbers wont be messed up.
            for (int i = 0; i < output.Length; i += 3)
            {
                output = output.Insert(i, ",");
            }
            output = output.Remove(0, 1);

            //numbers
            output = output.Replace("00", System.Environment.NewLine);
            output = output.Replace("01", " ");
            output = output.Replace("02", "0");
            output = output.Replace("03", "1");
            output = output.Replace("04", "2");
            output = output.Replace("05", "3");
            output = output.Replace("06", "4");
            output = output.Replace("07", "5");
            output = output.Replace("08", "6");
            output = output.Replace("09", "7");
            output = output.Replace("10", "8");
            output = output.Replace("11", "9");

            //char's
            output = output.Replace("12", "a");
            output = output.Replace("13", "b");
            output = output.Replace("14", "c");
            output = output.Replace("15", "d");
            output = output.Replace("16", "e");
            output = output.Replace("17", "f");
            output = output.Replace("18", "g");
            output = output.Replace("19", "h");
            output = output.Replace("20", "i");
            output = output.Replace("21", "j");
            output = output.Replace("22", "k");
            output = output.Replace("23", "l");
            output = output.Replace("24", "m");
            output = output.Replace("25", "n");
            output = output.Replace("26", "o");
            output = output.Replace("27", "p");
            output = output.Replace("28", "q");
            output = output.Replace("29", "r");
            output = output.Replace("30", "s");
            output = output.Replace("31", "t");
            output = output.Replace("32", "u");
            output = output.Replace("33", "v");
            output = output.Replace("34", "w");
            output = output.Replace("35", "x");
            output = output.Replace("36", "y");
            output = output.Replace("37", "z");

            //div
            output = output.Replace("38", "!");
            output = output.Replace("39", "[");
            output = output.Replace("40", "]");
            output = output.Replace("41", "=");
            output = output.Replace("42", ".");
            output = output.Replace("43", "&");
            output = output.Replace("44", "@");

            return output.Replace(",", "");
        }
    }
}
